"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_router_dom_1 = require("react-router-dom");
var react_helmet_1 = require("react-helmet");
var useRoute_1 = __importDefault(require("./useRoute"));
var routes_helpers_1 = require("./routes-helpers");
var Title = function (_a) {
    var title = _a.title;
    var routeState = (0, useRoute_1.default)();
    var theTitle = typeof title === "function" ? title(routeState) : title;
    return (react_1.default.createElement(react_helmet_1.Helmet, null,
        react_1.default.createElement("title", null, theTitle)));
};
var Route = function (_a) {
    var name = _a.name, onEnter = _a.onEnter, children = _a.children, title = _a.title, otherProps = __rest(_a, ["name", "onEnter", "children", "title"]);
    (0, routes_helpers_1.setCurrentRoute)(name);
    var routeState = (0, useRoute_1.default)();
    if (onEnter && !onEnter(routeState)) {
        return null;
    }
    return (react_1.default.createElement(react_router_dom_1.Route, __assign({}, otherProps),
        react_1.default.createElement(react_1.default.Fragment, null,
            title && react_1.default.createElement(Title, { title: title }),
            children)));
};
exports.default = Route;
