"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrentRoute = exports.setCurrentRoute = exports.regiterPath = exports.generateRoutePath = void 0;
var react_router_1 = require("react-router");
var routesMap = {};
var currentRoute = null;
var generateRoutePath = function (name, params) {
    var pattern = routesMap[name];
    var path = (0, react_router_1.generatePath)(pattern, params);
    return path;
};
exports.generateRoutePath = generateRoutePath;
var regiterPath = function (name, path) {
    if (!name || !path) {
        return;
    }
    routesMap[name] = path;
};
exports.regiterPath = regiterPath;
var setCurrentRoute = function (route) {
    currentRoute = route;
};
exports.setCurrentRoute = setCurrentRoute;
var getCurrentRoute = function () {
    if (!currentRoute) {
        return null;
    }
    var path = routesMap[currentRoute];
    return { name: currentRoute, path: path };
};
exports.getCurrentRoute = getCurrentRoute;
