"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_router_dom_1 = require("react-router-dom");
var routes_helpers_1 = require("./routes-helpers");
var useRoute = function () {
    var location = (0, react_router_dom_1.useLocation)();
    var history = (0, react_router_dom_1.useHistory)();
    var params = (0, react_router_dom_1.useParams)();
    var _a = (0, routes_helpers_1.getCurrentRoute)() || {}, name = _a.name, path = _a.path;
    var goRoute = function (routeName, routeParams) {
        var url = (0, routes_helpers_1.generateRoutePath)(routeName, routeParams);
        history.push(url);
    };
    var setRouteParams = function (ops) {
        var newParams = __assign(__assign({}, params), ops);
        var search = location.search;
        var url = (0, routes_helpers_1.generateRoutePath)(name, newParams) + (search ? search : '');
        history.replace(url);
    };
    var setQueryParams = function (ops, reset) {
        if (reset === void 0) { reset = true; }
        var pathname = location.pathname, search = location.search;
        var sString = search ? search.substring(1) : "";
        var queryParams = new URLSearchParams(reset ? "" : sString);
        Object.entries(ops).map(function (_a) {
            var key = _a[0], val = _a[1];
            if (!key) {
                return;
            }
            if (!val) {
                queryParams.delete(key);
                return;
            }
            queryParams.set(key, val);
        });
        var query = queryParams.toString();
        var fullUrl = "" + pathname + (query ? "?" + query : "");
        history.replace(fullUrl);
    };
    var queryParams = {};
    new URLSearchParams(location.search).forEach(function (value, key) {
        queryParams[key] = value;
    });
    return {
        name: name,
        path: path,
        location: location,
        history: history,
        url: location.pathname,
        params: params || {},
        setRouteParams: setRouteParams,
        queryParams: queryParams,
        setQueryParams: setQueryParams,
        goRoute: goRoute
    };
};
exports.default = useRoute;
